﻿//【登録場所】 "V2C\script\system\post.js"
//【内容】post.jsのまとめ
//【備考】checkBeforeCreateThreadとcheckBeforePostの{}内で、行頭のコメント「//」を、利用する行ごとに解除することで、有効になります。
//【スクリプト】
// ----- 次の行から -----
function checkBeforeCreateThread(wp){
  return true;
};

function checkBeforePost(wp){
  var post = true;
  return post
/* 機能を有効にしたい場合、下の各行頭//を削除してください  */
//    && escapeCharRef(wp) //文字参照をそのままスレッドに表示させる(&を&amp;に置換する、デフォルトはV2C提示版の'スクリプト'と'レス表示スタイル')
//    && replaceh(wp) //自動でURL先頭のhを文字参照(16進数)に置換する。(デフォルトはV2C提示版)
//    && removeh(wp) //自動でURL先頭のh抜きをする。(デフォルトはtwitter以外)
//    && replaceTab(wp) //書き込み時に【TAB】に自動置換（デフォルトはスレタイが'ImageViewURLReplace','ReplaceStr','URLExec'）
//    && closeWritePanel(wp) //書き込み後自動で閉じる（常に行う場合、メニューの設定で可能です。デフォルトはtwitter以外）
//    && checkBlankName(wp) //名前欄が空欄 or !ninja or !denki以外で警告（デフォルトはローカル板とtwitter以外）
//    && reloadBeforePost(wp) //書き込み前に更新して新着があれば書き込まない　※勢いのあるスレではそのまま書き込む（デフォルトはローカル板とtwitter以外）
};

// 対象文字列のチェック
function checkThStr(str, target) {
  var tlen, i;
  if ((tlen = target.length) > 0) {
    for (i=0; i<tlen; i++) {
      if (str.indexOf(target[i]) > 0) {
        return true;
      }
    }
  }
  return false;
}

function escapeCharRef(wp) {
  /* 設定 */
  var all = false; //常に有効にする場合 true
  /* 設定ここまで */
  
  var post = true;
  var th = wp.thread;
  var bbs = th.bbs;
  var url = th.board.url;
  var title = th.title;
  var ph = java.util.regex.Pattern.compile('&(#?\\w+;)');
  var targetTitle = ['スクリプト','レス表示スタイル'];
  if (
    all
    /* 個別のBBS・板・スレッドなどで有効にしたい場合、下の例を参考に各行頭//を削除するなどしてください  */
//    || bbs.is2ch //BBSが2chの場合
//    || bbs.is2cheq //BBSが2ch互換板の場合
//    || bbs.shitaraba //BBSがしたらばの場合
//    || bbs.machi //BBSがまちBBSの場合
//    || bbs.twitter //BBSがTwitterの場合
//    || th.local //スレッドがローカル板の場合
    || bbs.is2cheq && url.path == '/v2cj/' && checkThStr(title, targetTitle)//V2C提示版でスレタイが”スクリプト”または”レス表示スタイル”の場合
    /* 例ここまで */
    ) {
    var mh = ph.matcher(wp.message.text);
    if (mh.find() && v2c.confirm('文字参照が含まれています\n文字参照をそのまま表示(&を&amp;に置換)しますか？')){
      if (post) wp.message.text = mh.replaceAll('&amp;$1');
    }
  }
  return post;
};

function replaceh(wp) {
  /* 設定 */
  var all = false; //常に有効にする場合 true
  /* 設定ここまで */
  
  var post = true;
  var th = wp.thread;
  var bbs = th.bbs;
  var url = th.board.url;
  var ph = java.util.regex.Pattern.compile('h(ttps?://)');
  if (
    all
    /* 個別のBBS・板・スレッドなどで有効にしたい場合、下の例を参考に各行頭//を削除するなどしてください  */
//    || bbs.is2ch //BBSが2chの場合
//    || bbs.is2cheq //BBSが2ch互換板の場合
//    || bbs.shitaraba //BBSがしたらばの場合
//    || bbs.machi //BBSがまちBBSの場合
//    || bbs.twitter //BBSがTwitterの場合
//    || th.local //スレッドがローカル板の場合
    || bbs.is2cheq && url.path == '/v2cj/' //板がV2C提示版の場合
    /* 例ここまで */
    ) {
    var mh = ph.matcher(wp.message.text);
    if (mh.find()){
//      post = v2c.confirm('ｈ抜きを行い書き込みますか？'); //確認する場合は行頭//を削除
      if (post) wp.message.text = mh.replaceAll('&#x68;$1');
    }
  }
  return post;
};

function removeh(wp) {
  /* 設定 */
  var all = false; //常に有効にする場合 true
  /* 設定ここまで */
  
  var post = true;
  var th = wp.thread;
  var bbs = th.bbs;
  var url = th.board.url;
  var ph = java.util.regex.Pattern.compile('h(ttps?://)');
  if (
    all
    /* 個別のBBS・板・スレッドなどで有効にしたい場合、下の例を参考に各行頭//を削除するなどしてください  */
//    || bbs.is2ch //BBSが2chの場合
//    || bbs.is2cheq //BBSが2ch互換板の場合
//    || bbs.shitaraba //BBSがしたらばの場合
//    || bbs.machi //BBSがまちBBSの場合
//    || bbs.twitter //BBSがTwitterの場合
//    || th.local //スレッドがローカル板の場合
    || !bbs.twitter //BBSがtwitter以外の場合
//    || bbs.is2cheq && url.path == '/v2cj/' //板がV2C提示版の場合
    /* 例ここまで */
    ) {
    var mh = ph.matcher(wp.message.text);
    if (mh.find()){
//      post = v2c.confirm('ｈ抜きを行い書き込みますか？'); //確認する場合は行頭//を削除
      if (post) wp.message.text = mh.replaceAll('$1');
    }
  }
  return post;
};

function replaceTab(wp) {
  /* 設定 */
  var all = false; //常に有効にする場合 true
  /* 設定ここまで */
  
  var post = true;
  var th = wp.thread;
  var bbs = th.bbs;
  var url = th.board.url;
  var title = th.title;
  var ph = java.util.regex.Pattern.compile('\\t');
  var targetTitle = ['ImageViewURLReplace','ReplaceStr','URLExec'];
  if (
    all
    /* 個別のBBS・板・スレッドなどで有効にしたい場合、下の例を参考に各行頭//を削除するなどしてください  */
//    || bbs.is2ch //BBSが2chの場合
//    || bbs.is2cheq //BBSが2ch互換板の場合
//    || bbs.shitaraba //BBSがしたらばの場合
//    || bbs.machi //BBSがまちBBSの場合
//    || bbs.twitter //BBSがTwitterの場合
//    || th.local //スレッドがローカル板の場合
    || checkThStr(title, targetTitle)//スレタイが'ImageViewURLReplace','ReplaceStr','URLExec'の場合
    /* 例ここまで */
    ) {
    var mh = ph.matcher(wp.message.text);
    if (mh.find() && v2c.confirm('Tab文字が含まれています\n【TAB】に置換しますか？')){
      if (post) wp.message.text = mh.replaceAll('【TAB】');
    }
  }
  return post;
};

function closeWritePanel(wp) {
  /* 設定 */
  var all = false; //常に有効にする場合 true ※「設定→書き込み→書き込み後自動で閉じる」と同じ
  /* 設定ここまで */
  
  var post = true;
  var th = wp.thread;
  var bbs = th.bbs;
  var url = th.board.url;
  if (
    all
    /* 個別のBBS・板・スレッドなどで有効にしたい場合、下の例を参考に各行頭//を削除するなどしてください  */
//    || bbs.is2ch //BBSが2chの場合
//    || bbs.is2cheq //BBSが2ch互換板の場合
//    || bbs.shitaraba //BBSがしたらばの場合
//    || bbs.machi //BBSがまちBBSの場合
//    || bbs.twitter //BBSがTwitterの場合
//    || th.local //スレッドがローカル板の場合
    || !bbs.twitter //BBSがtwitter以外の場合
    /* 例ここまで */
    ) {
    wp.close();
  }
  return post;
};

function reloadBeforePost(wp) {
  /* 設定 */
  var all = false; //常に有効にする場合 true
  var lowerBoundSpeed = 0;//スレの勢いの下限
  var upperBoundSpeed = 30000;//スレの勢いの上限　勢い下限と上限の間にあるスレのみ事前更新でチェックしてから書込する
  /* 設定ここまで */
  
  var post = true;
  var th = wp.thread;
  var bbs = th.bbs;
  var url = th.board.url;
  if (
    all
    /* 個別のBBS・板・スレッドなどで有効にしたい場合、下の例を参考に各行頭//を削除するなどしてください  */
//    || bbs.is2ch //BBSが2chの場合
//    || bbs.is2cheq //BBSが2ch互換板の場合
//    || bbs.shitaraba //BBSがしたらばの場合
//    || bbs.machi //BBSがまちBBSの場合
//    || bbs.twitter //BBSがTwitterの場合
//    || th.local //スレッドがローカル板の場合
    || (!th.local && !bbs.twitter) //スレッドがローカル板とtwitter以外の場合
    /* 例ここまで */
    ) {
    if (lowerBoundSpeed <= th.speed && th.speed <= upperBoundSpeed) {
      if (th.updateAndWait()) { //更新失敗ならfalseになる→falseの時はそのまま書きこむ
        post = th.newResCount == 0;
      }
    }
  }
  return post;
};

function checkBlankName(wp) {
  /* 設定 */
  var all = false; //常に有効にする場合 true
  /* 設定ここまで */
  
  var post = true;
  var th = wp.thread;
  var bbs = th.bbs;
  var url = th.board.url;
  var ph = java.util.regex.Pattern.compile('^(!ninja|!denki)?$');
  if (
    all
    /* 個別のBBS・板・スレッドなどで有効にしたい場合、下の例を参考に各行頭//を削除するなどしてください  */
//    || bbs.is2ch //BBSが2chの場合
//    || bbs.is2cheq //BBSが2ch互換板の場合
//    || bbs.shitaraba //BBSがしたらばの場合
//    || bbs.machi //BBSがまちBBSの場合
//    || bbs.twitter //BBSがTwitterの場合
//    || th.local //スレッドがローカル板の場合
    || (!th.local && !bbs.twitter) //スレッドがローカル板とtwitter以外の場合
    /* 例ここまで */
    ) {
    var mh = ph.matcher(wp.name.text);
    if (!mh.find() && !v2c.confirm('名前欄が空欄ではありません。\n書き込みを行いますか？')){
      post = false;
    }
  }
  return post;
};
